There's a useful thread at
http://forums.oscommerce.com/index.php?showtopic=179130
forthose wrestling with issues related to OSCommerce and MySQL Version 5.

It may be far easier to just upgrade to a newer version of OSCommerce ... the more recent versions seem to have fewer issues...